package com.zhongzheng.modules.grade.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.grade.bo.ClassGradeSysAddBo;
import com.zhongzheng.modules.grade.bo.ClassGradeSysQueryBo;
import com.zhongzheng.modules.grade.bo.ClassGradeSysEditBo;
import com.zhongzheng.modules.grade.domain.ClassGradeSys;
import com.zhongzheng.modules.grade.mapper.ClassGradeSysMapper;
import com.zhongzheng.modules.grade.vo.ClassGradeSysVo;
import com.zhongzheng.modules.grade.service.IClassGradeSysService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 班主任记录Service业务层处理
 *
 * @author ruoyi
 * @date 2021-11-10
 */
@Service
public class ClassGradeSysServiceImpl extends ServiceImpl<ClassGradeSysMapper, ClassGradeSys> implements IClassGradeSysService {

    @Override
    public ClassGradeSysVo queryById(Long id){
        ClassGradeSys db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ClassGradeSysVo.class);
    }

    @Override
    public List<ClassGradeSysVo> queryList(ClassGradeSysQueryBo bo) {
        return entity2Vo(baseMapper.select(bo));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ClassGradeSysVo> entity2Vo(Collection<ClassGradeSysVo> collection) {
        List<ClassGradeSysVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ClassGradeSysVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ClassGradeSysVo> page = (Page<ClassGradeSysVo>)collection;
            Page<ClassGradeSysVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ClassGradeSysAddBo bo) {
        ClassGradeSys add = BeanUtil.toBean(bo, ClassGradeSys.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ClassGradeSysEditBo bo) {
        ClassGradeSys update = BeanUtil.toBean(bo, ClassGradeSys.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ClassGradeSys entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
